#!/usr/bin/perl

use Data::RandomPerson;

my $drp  = Data::RandomPerson->new();
my $p    = $drp->create();
my $name = $p->{firstname} . ' ' . $p->{lastname};

print <<"XEOF";
Content-Type: text/html


<!--
 ____________________________________________________________
|                                                            |
|    DESIGN + Pat Heard { http://fullahead.org }             |
|      DATE + 2006.03.19                                     |
| COPYRIGHT + Free use if this notice is left in place       |
|____________________________________________________________|

-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en-AU">

<head>


  <title>da-op3n certificate authority</title>

  <meta http-equiv="content-type" content="application/xhtml+xml; charset=UTF-8" />

  <link rel="stylesheet" type="text/css" href="css/html.css" media="screen, projection, tv " />
  <link rel="stylesheet" type="text/css" href="css/layout.css" media="screen, projection, tv" />
  <link rel="stylesheet" type="text/css" href="css/print.css" media="print" />

</head>


<body>

<!-- CONTENT: Holds all site content except for the footer.  This is what causes the footer to stick to the bottom -->
<div id="content">



  <!-- HEADER: Holds title, subtitle and header images -->
  <div id="header">

    <div id="title">
      <h1>DA-Op3n ca interface</h1>
      <h2>crypto fun</h2>
    </div>

    <img src="images/bg/balloons.gif" alt="balloons" class="balloons" />
    <img src="images/bg/header_left.jpg" alt="left slice" class="left" />
    <img src="images/bg/header_right.jpg" alt="right slice" class="right" />

  </div>



  <!-- MAIN MENU: Top horizontal menu of the site.  Use class="here" to turn the current page tab on -->
  <div id="mainMenu">
    <ul class="floatRight">
      <li><a href="index.html">Intro</a></li>
      <li><a href="get_free_cert.cgi">Enroll</a></li>
      <li><a href="revoke.html">Revoke</a></li>
      <li><a href="whois.html">Whois</a></li>
      <li><a href="register.html">Register</a></li>
      <li><a href="login.html">Login</a><li>
      <li><a href="messages.cgi">Messages</a></li>
      <li><a href="key_compromise.html">Key br0ken</a></li>
    </ul>
  </div>




  <!-- PAGE CONTENT BEGINS: This is where you would define the columns (number, width and alignment) -->
  <div id="page">


    <!-- 25 percent width column, aligned to the left -->
    <div class="width25 floatLeft leftColumn">

      <h1>Login</h1>

      <ul class="sideMenu">
        <li class="here">
          <form action="login.cgi">
          <table>
              <tr>
                  <td>user</td>
                  <td><input type="text" name="username" size=10></td>
              </tr>
              <tr>
                  <td>password</td>
                  <td><input type="password" name="password" size=10></td>
              </tr>
              <tr>
                  <td></td>
                  <td><input type="submit" value="log me in"></td>
              </tr>
          </table>
          </form>
    </div>




    <!-- 75 percent width column, aligned to the right -->
    <div class="width75 floatRight">


      <!-- Gives the gradient block -->
      <div class="gradient">

        <a name="fluidity"></a>

        <h1>Get a free user certificate</h1>

        <h2>Key generated on the CA</h2>
          <p>You can let the CA issue a free user certificate in your name here. Please enter your name and a good password to download a PKCS#12 file.</p>
          <p>
          <form action="issue_cert.cgi">
          <table border=0>
            <tr>
              <td>Name/Pseudonym:</td><td><input type="text" name="subject" value="$name"/></td>
            </tr>
            <tr>
              <td>Password:</td><td><input type="password" name="password"/></td>
            </tr>
            <tr>
              <td></td><td><input type="submit" value="Get certificate"/></td>
            </tr>
          </table>
          </form>
          </p>
          <h2>Key generated on your machine</h2>
          <p>Alternatively, you can paste an existing certificate or a certificate request below to issue a certificate for a given public key ...</p>
          <p>
            <form action="issue_cert_req.cgi">
            <p>
            <textarea name="request" cols=65 rows=20></textarea>
            </p>
            <p>
            <input type="submit" value="Get certificate"/>
            </p>
            </form>
          </p>

        <blockquote>
          <p>
          Think of a monad as a spacesuit full of nuclear waste in the ocean next to a container of apples. Now, you can't put oranges in the space suite or the nuclear waste falls in the ocean, but the apples are carried around anyway, and you just take what you need.
           <span class="block small grey"><a href="http://en.wikiquote.org/wiki/Programming#Haskell">Don Stewart</a></span>
          </p>
        </blockquote>
      </div>

    </div>

  </div>

</div>


<!-- FOOTER: Site footer for links, copyright, etc. -->
<div id="footer">

  <div id="width">
    <span class="floatLeft">
        design <a href="http://fullahead.org" title="Goto Fullahead">Fullahead</a> <span class="grey">| <a href="http://www.oswd.org/design/information/id/2839">lazy days on oswd</a></span>
    </span>

    <span class="floatRight">
        code: alech
    </span>
  </div>

</div>

</body>

</html>
XEOF
